%[x y]=tabellStopDate(100,temps,'9-Feb-2012','31-May-2012')
t=cputime;
model=0;
startdate='09-jul-2012';
stopdate='09-jun-2014';
stopreleasedate='26-nov-2012';
stoptwoweeksdate='10-jun-2013';
startdate=datenum(startdate);
stopdate=datenum(stopdate);
stopreleasedate=datenum(stopreleasedate);
stoptwoweeksdate=datenum(stoptwoweeksdate);
load('averagetemps');%The temperature scenarios are stored in a separate file called scenariotemps.mat. The variable name is scenariotemps.
load('smoltweights');
numberofreleaseperiods=floor(stopreleasedate-startdate)/14 +1;
numberofperiods=floor(stopdate-startdate)/14 +1;
numberoftwoweeksperiods(1)=floor(stoptwoweeksdate-startdate)/14 +1;
numberoftwoweeksperiods(2)=floor(stoptwoweeksdate-(startdate+364))/14 +1;
numberoftwoweeksperiods(3)=floor(stoptwoweeksdate-(startdate+364*2))/14 +1;
numberofsmoltweights=length(smoltweights);
filename='SMOLTS0_SECONDSTAGE.dat';
fid=fopen(filename,'w');
fclose(fid);



Weighttable1=[];
Weighttable2=[];
Weighttable3=[];
Profittable1=[];
Profittable2=[];
Profittable3=[];
tablename1=strcat('SMOLTS0_SECONDSTAGE1');
tablename2=strcat('SMOLTS0_SECONDSTAGE2');
tablename3=strcat('SMOLTS0_SECONDSTAGE3');
tablename=strcat('SMOLTS0_SECONDSTAGE');


HARVESTweights=[4000 6000];
numberofHARVESTweights=length(HARVESTweights);

  Weight=[]; 
for k=1:numberofHARVESTweights
    HARVESTweight=HARVESTweights(k);
for j=1:numberofsmoltweights
    fprintf(strcat(tablename,'\n'));
    outtable=zeros(numberofperiods, numberofreleaseperiods);
    A=zeros(numberofperiods,numberofreleaseperiods);
    C=zeros(numberofperiods,numberofreleaseperiods);
    for i=1:numberofreleaseperiods
        sdate=startdate+14*(i-1);
        [x y]=tabellStopDate(smoltweights(j),averagetemps,sdate,stopdate,model,HARVESTweight);
        outtable(i:numberofperiods,i)=y;

    end
    
    
    

Weighttable1=[Weighttable1;outtable(1:numberoftwoweeksperiods(1),:);outtable(numberoftwoweeksperiods(1)+1:2:numberofperiods,:)];
Weighttable2=[Weighttable2;outtable(1:2:numberofperiods,:)];
Weighttable3=[Weighttable3;outtable(1:2:numberofperiods-4,:)];
end
end
[x y]=size(Weighttable1);
  Harvesttable1=zeros(x,y);
  l=x;
  l2=l;
  m=x/(numberofHARVESTweights*numberofsmoltweights);
  m2=m;
  n=2*x/(numberofHARVESTweights*numberofsmoltweights);
  n2=n;
  o=3*x/(numberofHARVESTweights*numberofsmoltweights);
  o2=o;
  p=4*x/(numberofHARVESTweights*numberofsmoltweights);
  p2=p;
  q=5*x/(numberofHARVESTweights*numberofsmoltweights);
  q2=q;
  r=6*x/(numberofHARVESTweights*numberofsmoltweights);
  r2=r;
  s=7*x/(numberofHARVESTweights*numberofsmoltweights);
  s2=s;
  
  
for k=1:numberofreleaseperiods
  while Weighttable1(l,k)==0
           l=l-1;  
  end

       if l~=l2
            Harvesttable1(l,k)=1;
       elseif Weighttable1(l2,k)>=5600
           Harvesttable1(l2,k)=1;
       
       end
       l=x;
       while Weighttable1(m,k)==0 
            m=m-1;
       end
       if m~=m2
            Harvesttable1(m,k)=1;

       elseif Weighttable1(m2,k)>=3800
           Harvesttable1(m2,k)=1;
       end
       m=x/(numberofHARVESTweights*numberofsmoltweights);
       while Weighttable1(n,k)==0 
            n=n-1;
       end
       if n~=n2
            Harvesttable1(n,k)=1;
      
       elseif Weighttable1(n2,k)>=3800
           Harvesttable1(n2,k)=1;
       end
       n=2*x/(numberofHARVESTweights*numberofsmoltweights);
       while Weighttable1(o,k)==0 
            o=o-1;
       end
       if o~=o2
            Harvesttable1(o,k)=1;
      
       elseif Weighttable1(o2,k)>=3800
           Harvesttable1(o2,k)=1;
       end
       o=3*x/(numberofHARVESTweights*numberofsmoltweights);
       while Weighttable1(p,k)==0 
            p=p-1;
       end
       if p~=p2
            Harvesttable1(p,k)=1;
      
       elseif Weighttable1(p2,k)>=3800
           Harvesttable1(p2,k)=1;
       end
       p=4*x/(numberofHARVESTweights*numberofsmoltweights);
       while Weighttable1(q,k)==0 
            q=q-1;
       end
       if q~=q2
            Harvesttable1(q,k)=1;
      
       elseif Weighttable1(q2,k)>=5600
           Harvesttable1(q2,k)=1;
       end
       q=5*x/(numberofHARVESTweights*numberofsmoltweights);
       while Weighttable1(r,k)==0 
            r=r-1;
       end
       if r~=r2
            Harvesttable1(r,k)=1;
      
       elseif Weighttable1(r2,k)>=5600
           Harvesttable1(r2,k)=1;
       end
       r=6*x/(numberofHARVESTweights*numberofsmoltweights);
       while Weighttable1(s,k)==0 
            s=s-1;
       end
       if s~=s2
            Harvesttable1(s,k)=1;
      
       elseif Weighttable1(s2,k)>=5600
           Harvesttable1(s2,k)=1;
       end
       s=7*x/(numberofHARVESTweights*numberofsmoltweights);
end
Profittable1=Harvesttable1.*Weighttable1/1000;



 [x y]=size(Weighttable2);
  Harvesttable2=zeros(x,ceil(y/2));
  Weight2=zeros(x,ceil(y/2));
  Weight2=Weighttable2(1:x,1:2:y);
  l=x;
  l2=l;
  m=x/(numberofHARVESTweights*numberofsmoltweights);
  m2=m;
  n=2*x/(numberofHARVESTweights*numberofsmoltweights);
  n2=n;
  o=3*x/(numberofHARVESTweights*numberofsmoltweights);
  o2=o;
  p=4*x/(numberofHARVESTweights*numberofsmoltweights);
  p2=p;
  q=5*x/(numberofHARVESTweights*numberofsmoltweights);
  q2=q;
  r=6*x/(numberofHARVESTweights*numberofsmoltweights);
  r2=r;
  s=7*x/(numberofHARVESTweights*numberofsmoltweights);
  s2=s;
  
  
for k=1:ceil(y/2)
  while Weight2(l,k)==0
           l=l-1;  
  end

       if l~=l2
            Harvesttable2(l,k)=1;
       elseif Weight2(l2,k)>=5600
           Harvesttable2(l2,k)=1;
       
       end
       l=x;
       while Weight2(m,k)==0 
            m=m-1;
       end
       if m~=m2
            Harvesttable2(m,k)=1;

       elseif Weight2(m2,k)>=3800
           Harvesttable2(m2,k)=1;
       end
       m=x/(numberofHARVESTweights*numberofsmoltweights);
       while Weight2(n,k)==0 
            n=n-1;
       end
       if n~=n2
            Harvesttable2(n,k)=1;
      
       elseif Weight2(n2,k)>=3800
           Harvesttable2(n2,k)=1;
       end
       n=2*x/(numberofHARVESTweights*numberofsmoltweights);
       while Weight2(o,k)==0 
            o=o-1;
       end
       if o~=o2
            Harvesttable2(o,k)=1;
      
       elseif Weight2(o2,k)>=3800
           Harvesttable2(o2,k)=1;
       end
       o=3*x/(numberofHARVESTweights*numberofsmoltweights);
       while Weight2(p,k)==0 
            p=p-1;
       end
       if p~=p2
            Harvesttable2(p,k)=1;
      
       elseif Weight2(p2,k)>=3800
           Harvesttable2(p2,k)=1;
       end
       p=4*x/(numberofHARVESTweights*numberofsmoltweights);
       while Weight2(q,k)==0 
            q=q-1;
       end
       if q~=q2
            Harvesttable2(q,k)=1;
      
       elseif Weight2(q2,k)>=5600
           Harvesttable2(q2,k)=1;
       end
       q=5*x/(numberofHARVESTweights*numberofsmoltweights);
       while Weight2(r,k)==0 
            r=r-1;
       end
       if r~=r2
            Harvesttable2(r,k)=1;
      
       elseif Weight2(r2,k)>=5600
           Harvesttable2(r2,k)=1;
       end
       r=6*x/(numberofHARVESTweights*numberofsmoltweights);
       while Weight2(s,k)==0 
            s=s-1;
       end
       if s~=s2
            Harvesttable2(s,k)=1;
      
       elseif Weight2(s2,k)>=5600
           Harvesttable2(s2,k)=1;
       end
       s=7*x/(numberofHARVESTweights*numberofsmoltweights);
end
Profittable2=Harvesttable2.*Weight2/1000;

  [x y]=size(Weighttable3);
  Weight3=zeros(x, ceil(y/2));
  
  Weight3=Weighttable3(1:x,1:2:y);
  Harvesttable3=zeros(x,ceil(y/2));
 l=x;
  l2=l;
  m=x/(numberofHARVESTweights*numberofsmoltweights);
  m2=m;
  n=2*x/(numberofHARVESTweights*numberofsmoltweights);
  n2=n;
  o=3*x/(numberofHARVESTweights*numberofsmoltweights);
  o2=o;
  p=4*x/(numberofHARVESTweights*numberofsmoltweights);
  p2=p;
  q=5*x/(numberofHARVESTweights*numberofsmoltweights);
  q2=q;
  r=6*x/(numberofHARVESTweights*numberofsmoltweights);
  r2=r;
  s=7*x/(numberofHARVESTweights*numberofsmoltweights);
  s2=s;
  
  
for k=1:ceil(y/2)
  while Weight3(l,k)==0
           l=l-1;  
  end

       if l~=l2
            Harvesttable3(l,k)=1;
       elseif Weight3(l2,k)>=5600
           Harvesttable3(l2,k)=1;
       
       end
       l=x;
       while Weight3(m,k)==0 
            m=m-1;
       end
       if m~=m2
            Harvesttable3(m,k)=1;

       elseif Weight3(m2,k)>=3800
           Harvesttable3(m2,k)=1;
       end
       m=x/(numberofHARVESTweights*numberofsmoltweights);
       while Weight3(n,k)==0 
            n=n-1;
       end
       if n~=n2
            Harvesttable3(n,k)=1;
      
       elseif Weight3(n2,k)>=3800
           Harvesttable3(n2,k)=1;
       end
       n=2*x/(numberofHARVESTweights*numberofsmoltweights);
       while Weight3(o,k)==0 
            o=o-1;
       end
       if o~=o2
            Harvesttable3(o,k)=1;
      
       elseif Weight3(o2,k)>=3800
           Harvesttable3(o2,k)=1;
       end
       o=3*x/(numberofHARVESTweights*numberofsmoltweights);
       while Weight3(p,k)==0 
            p=p-1;
       end
       if p~=p2
            Harvesttable3(p,k)=1;
      
       elseif Weight3(p2,k)>=3800
           Harvesttable3(p2,k)=1;
       end
       p=4*x/(numberofHARVESTweights*numberofsmoltweights);
       while Weight3(q,k)==0 
            q=q-1;
       end
       if q~=q2
            Harvesttable3(q,k)=1;
      
       elseif Weight3(q2,k)>=5600
           Harvesttable3(q2,k)=1;
       end
       q=5*x/(numberofHARVESTweights*numberofsmoltweights);
       while Weight3(r,k)==0 
            r=r-1;
       end
       if r~=r2
            Harvesttable3(r,k)=1;
      
       elseif Weight3(r2,k)>=5600
           Harvesttable3(r2,k)=1;
       end
       r=6*x/(numberofHARVESTweights*numberofsmoltweights);
       while Weight3(s,k)==0 
            s=s-1;
       end
       if s~=s2
            Harvesttable3(s,k)=1;
      
       elseif Weight3(s2,k)>=5600
           Harvesttable3(s2,k)=1;
       end
       s=7*x/(numberofHARVESTweights*numberofsmoltweights);
end
Profittable3=Harvesttable3.*Weight3/1000;
    
appendtofile(filename,tablename1,Weighttable1);
appendintegermatrixtofile(filename,strcat(tablename1,'HARVEST \n'),Harvesttable1);
appendtofile(filename,strcat(tablename1,'PROFIT \n'),Profittable1);
appendtofile(filename,tablename2,Weight2);
appendintegermatrixtofile(filename,strcat(tablename2,'HARVEST \n'),Harvesttable2);
appendtofile(filename,strcat(tablename2,'PROFIT \n'),Profittable2);
appendtofile(filename,tablename3,Weight3);
appendintegermatrixtofile(filename,strcat(tablename3,'HARVEST \n'),Harvesttable3);
appendtofile(filename,strcat(tablename3,'PROFIT \n'),Profittable3);


t2=cputime;
t2-t;