filename='global_data.dat'
fid=fopen(filename,'w');

%Antall vektklasser
load('weightclass');
nWeightClasses=length(weightclass);
WeightClasses=[1:nWeightClasses];
fprintf(fid, strcat('WeightClasses: \t[',num2str(WeightClasses),']\n'));

%Antall scenarier
load('scenariotemps')
[x y]=size(scenariotemps)
nScenarioTemps=x;
ScenarioTemps=[1:nScenarioTemps];
fprintf(fid, strcat('NGROWTHSCENARIOS: \t',num2str(nScenarioTemps),'\n'));
fprintf(fid, strcat('GrowthScenarios: \t[',num2str(ScenarioTemps),']\n'));

%Antall perioder i frste steg
startdate='16-May-2011';
stopdate='28-Nov-2011';
stoptwoweeksdate='10-jun-2013';
startdate=datenum(startdate);
stopdate=datenum(stopdate);
stoptwoweeksdate=datenum(stoptwoweeksdate);
nPeriodsStage1=floor(stopdate-startdate)/14 +1;
PeriodsStage1=[1:nPeriodsStage1];
fprintf(fid, strcat('PeriodsStage1: \t[',num2str(PeriodsStage1),']\n'));

%antall utsettsperioder i frste steg
startreleasedate='11-July-2011';
stopreleasedate='28-nov-2011';
startreleasedate=datenum(startreleasedate);
stopreleasedate=datenum(stopreleasedate);
nReleasePeriodsStage1=floor(stopreleasedate-startreleasedate)/14 +1;

%antall perioder steg 2
startdate2='12-Des-2011';
stopdate2='9-may-2016';
startdate2=datenum(startdate2);
stopdate2=datenum(stopdate2);
nPeriodsStage2=floor((stoptwoweeksdate-startdate2)/14) +1+(floor((stopdate2-stoptwoweeksdate+1)/14) +1)/2;
PeriodsStage2=[1+nPeriodsStage1:nPeriodsStage1+nPeriodsStage2];
fprintf(fid, strcat('PeriodsStage2: \t[',num2str(PeriodsStage2),']\n'));

%antall perioder totalt
nTotalPeriods=nPeriodsStage1+nPeriodsStage2;
Periods=[1:nTotalPeriods];
fprintf(fid, strcat('Periods:\t[',num2str(Periods),']\n'));

% nGrowthPeriodsStage1=52;
% nGrowthPeriodsStage2=52;
% fprintf(fid, strcat('nGrowthPeriodsStage1: \t',num2str(nGrowthPeriodsStage1),'\n'));
% fprintf(fid, strcat('nGrowthPeriodsStage2: \t',num2str(nGrowthPeriodsStage2),'\n'));


load('smoltweights');
%appendtofile
fprintf(fid, strcat('SmoltTypes: \t[',num2str(smoltweights),']\n'));
%Tillatte utsettsperioder


%Slakteperioder m fikses
fprintf(fid, strcat('nHarvestSmoothedPeriods: \t',num2str(1),'\n'));
fprintf(fid, strcat('lHarvestSmoothedPeriods: \t',num2str(1),'\n'));

%Navn p vektorer
fprintf(fid, strcat('Facilities:["trond_a1" "trond_s2" "trond_a2" "trond_s1" "more_a1" "more_s2" "more_a2" "more_s1"]','\n'));
fprintf(fid, strcat('Facilities_trond:["trond_a1" "trond_s2" "trond_a2" "trond_s1"]','\n'));
fprintf(fid, strcat('Facilities_more:["more_a1" "more_s2" "more_a2" "more_s1"]','\n'));
fprintf(fid, strcat('Facilities_autumn:["trond_a1" "trond_a2" "more_a1" "more_a2"]','\n'));
fprintf(fid, strcat('Facilities_spring:["trond_s1" "trond_s2" "more_s1" "more_s2"]','\n'));
fprintf(fid, strcat('Facilities_autumngrowth1:["trond_a2" "more_a2"]','\n'));
fprintf(fid, strcat('Facilities_autumngrowth2:["trond_a1" "more_a1"]','\n'));
fprintf(fid, strcat('Facilities_autumngrowth3:["trond_a2" "more_a2"]','\n'));
fprintf(fid, strcat('Facilities_springgrowth1:["trond_s2" "more_s2"]','\n'));
fprintf(fid, strcat('Facilities_springgrowth2:["trond_s1" "more_s1"]','\n'));
fprintf(fid, strcat('Facilities_springgrowth3:["trond_s2" "more_s2"]','\n'));
fprintf(fid, strcat('Facilities_stage1:["trond_a1" "more_a1"]','\n'));
fprintf(fid, strcat('Regions:["Trondelag" "More"]','\n'));
fprintf(fid, strcat('HarvestWeights: [',num2str([4000 6000]),']\n'));

    FirstStageRelease=[5:15];
    AutumnRelease1=[32:42];
	AutumnRelease2=[57:62];
	AutumnRelease3=[70:75];
	SpringRelease1=[21:31];
	SpringRelease2=[47:56];
	SpringRelease3=[65:69];
%     %CopySpring2=[77];
%     CopySpring3=[90];
%     CopyAutumn2=[82]; 
%     
	SalmonGrowthStage2=[16:56];
	AutumnGrowth1=[32:69];
	AutumnGrowth2=[57:82];
	AutumnGrowth3=[70:93];
	SpringGrowth1=[21:63];
	SpringGrowth2=[47:76];
	SpringGrowth3=[65:89];
fprintf(fid, strcat('FirstStageRelease: \t[',num2str(FirstStageRelease),']\n'));
fprintf(fid, strcat('AutumnRelease1: \t[',num2str(AutumnRelease1),']\n'));
fprintf(fid, strcat('AutumnRelease2: \t[',num2str(AutumnRelease2),']\n'));
fprintf(fid, strcat('AutumnRelease3: \t[',num2str(AutumnRelease3),']\n'));
fprintf(fid, strcat('SpringRelease1: \t[',num2str(SpringRelease1),']\n'));
fprintf(fid, strcat('SpringRelease2: \t[',num2str(SpringRelease2),']\n'));
fprintf(fid, strcat('SpringRelease3: \t[',num2str(SpringRelease3),']\n'));
fprintf(fid, strcat('SalmonGrowthStage2: \t[',num2str(SalmonGrowthStage2),']\n'));
fprintf(fid, strcat('AutumnGrowth1: \t[',num2str(AutumnGrowth1),']\n'));
fprintf(fid, strcat('AutumnGrowth2: \t[',num2str(AutumnGrowth2),']\n'));
fprintf(fid, strcat('AutumnGrowth3: \t[',num2str(AutumnGrowth3),']\n'));
fprintf(fid, strcat('SpringGrowth1: \t[',num2str(SpringGrowth1),']\n'));
fprintf(fid, strcat('SpringGrowth2: \t[',num2str(SpringGrowth2),']\n'));
fprintf(fid, strcat('SpringGrowth3: \t[',num2str(SpringGrowth3),']\n'));
% fprintf(fid, strcat('CopySpring2: \t[',num2str(CopySpring2),']\n'));
% fprintf(fid, strcat('CopySpring3: \t[',num2str(CopySpring3),']\n'));
% fprintf(fid, strcat('CopyAutumn2: \t[',num2str(CopyAutumn2),']\n'));
fprintf(fid, strcat('MortalityScenarios: \t[',num2str(0.95),'\t',num2str(0.9),'\t',num2str(0.85),'\t',num2str(0.8),'\t',num2str(0.75),']\n'));
fprintf(fid, strcat('SURVIVALRATESECONDSTAGE: \t[',num2str(0.85),']\n'));
%perioder SalmonStage2
startdateStage2='12-des-2011';
stopdateStage2='24-june-2013';
startdateStage2=datenum(startdateStage2);
stopdateStage2=datenum(stopdateStage2);
nGrowthPeriodsSalmonStage2=floor(stopdateStage2-startdateStage2)/14 +1;
%fprintf(fid, strcat('nGrowthPeriodsSalmonStage2: \t',num2str(nGrowthPeriodsSalmonStage2),'\n'));
fprintf(fid, strcat('MTB_REGION:\t[',num2str(32760000),'\t',num2str(7800000),']\n'));
%Inngende Balanse
n=length(weightclass);
%max smoltleveranse per sesong
SmoltReleaseMax_AutumnTotal= [15000  3500    1500   1000];
SmoltReleaseMax_SpringTotal= [15000  15000   3000    2000];
fprintf(fid, strcat('SMOLTRELEASEMAX_AUTUMNTOTAL: \t[',num2str(SmoltReleaseMax_AutumnTotal),']\n'));
fprintf(fid, strcat('SMOLTRELEASEMAX_SPRINGTOTAL: \t[',num2str(SmoltReleaseMax_SpringTotal),']\n'));
SmoltReleaseMax_FirstStage= [
1000	1000	1000	1000
1000	1000	1000	1000
1000	1000	1000	1000
1000	1000	1000	1000
1000	1000	1000	1000
1000	1000	1000	1000
1000	1000	1000	1000
1000	1000	1000	1000
1000	1000	1000	1000
0	0	1000	1000
0	0	1000	1000
];
SmoltReleaseMax_Autumn1=[
1000	1000	1000	1000
1000	1000	1000	1000
1000	1000	1000	1000
1000	1000	1000	1000
1000	1000	1000	1000
1000	1000	1000	1000
1000	1000	1000	1000
1000	1000	1000	1000
1000	1000	1000	1000
0	0	1000	1000
0	0	1000	1000
];
SmoltReleaseMax_Autumn2=[
2000	2000	2000	2000
2000	2000	2000	2000
2000	2000	2000	2000
2000	2000	2000	2000
2000	2000	2000	2000
0	0	2000	2000
];
SmoltReleaseMax_Autumn3=[
2000	2000	2000	2000
2000	2000	2000	2000
2000	2000	2000	2000
2000	2000	2000	2000
2000	2000	2000	2000
0	0	2000	2000
];
SmoltReleaseMax_Spring1=[
0	0	1000	1000
0	0	1000	1000
1000	1000	1000	1000
1000	1000	1000	1000
1000	1000	1000	1000
1000	1000	1000	1000
1000	1000	1000	1000
1000	1000	1000	1000
1000	1000	1000	1000
1000	1000	1000	1000
1000	1000	1000	1000
];
SmoltReleaseMax_Spring2=[
0	0	1000	1000
0	0	1000	1000
1000	1000	1000	1000
1000	1000	1000	1000
1000	1000	1000	1000
1000	1000	1000	1000
1000	1000	1000	1000
1000	1000	1000	1000
1000	1000	1000	1000
1000	1000	1000	1000
];
SmoltReleaseMax_Spring3=[
0	0	2000	2000
2000	2000	2000	2000
2000	2000	2000	2000
2000	2000	2000	2000
2000	2000	2000	2000
];
fclose(fid);
appendtofile(filename,'SMOLTRELEASEMAX_FIRSTSTAGE',SmoltReleaseMax_FirstStage);
appendtofile(filename,'SMOLTRELEASEMAX_AUTUMN1',SmoltReleaseMax_Autumn1);
appendtofile(filename,'SMOLTRELEASEMAX_AUTUMN2',SmoltReleaseMax_Autumn2);
appendtofile(filename,'SMOLTRELEASEMAX_AUTUMN3',SmoltReleaseMax_Autumn3);
appendtofile(filename,'SMOLTRELEASEMAX_SPRING1',SmoltReleaseMax_Spring1);
appendtofile(filename,'SMOLTRELEASEMAX_SPRING2',SmoltReleaseMax_Spring2);
appendtofile(filename,'SMOLTRELEASEMAX_SPRING3',SmoltReleaseMax_Spring3);

IB=[
0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000
0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000
0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.1000	0.1000	0.1000	0.1000	0.1000	0.1000	0.1000	0.1000	0.1000	0.0000
0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.1000	0.1000	0.1000	0.1000	0.1000	0.1000	0.1000	0.1000	0.1000	0.1000	0.1000	0.0000
0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000
0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000
0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.1000	0.1000	0.1000	0.1000	0.1000	0.1000	0.1000	0.1000	0.1000	0.0000
0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000	0.0000
];
appendtofile(filename,'IB',IB);
%MTB_fac
MTB_fac=[
10530000.0000	46540000.0000	29120000.0000	24960000.0000	5460000.0000	6240000.0000	10920000.0000	0.0000
10530000.0000	46540000.0000	29120000.0000	24960000.0000	5460000.0000	6240000.0000	10920000.0000	0.0000
0.0000	46540000.0000	29120000.0000	24960000.0000	0.0000	6240000.0000	10920000.0000	0.0000
0.0000	46540000.0000	29120000.0000	24960000.0000	0.0000	6240000.0000	10920000.0000	0.0000
21060000.0000	46540000.0000	29120000.0000	24960000.0000	10920000.0000	6240000.0000	10920000.0000	0.0000
21060000.0000	46540000.0000	29120000.0000	24960000.0000	10920000.0000	6240000.0000	10920000.0000	0.0000
21060000.0000	46540000.0000	29120000.0000	24960000.0000	10920000.0000	6240000.0000	10920000.0000	0.0000
21060000.0000	46540000.0000	29120000.0000	24960000.0000	10920000.0000	6240000.0000	10920000.0000	0.0000
21060000.0000	46540000.0000	29120000.0000	24960000.0000	10920000.0000	6240000.0000	10920000.0000	0.0000
21060000.0000	46540000.0000	29120000.0000	24960000.0000	10920000.0000	6240000.0000	10920000.0000	0.0000
21060000.0000	46540000.0000	29120000.0000	24960000.0000	10920000.0000	6240000.0000	10920000.0000	0.0000
21060000.0000	46540000.0000	29120000.0000	24960000.0000	10920000.0000	6240000.0000	10920000.0000	0.0000
21060000.0000	46540000.0000	29120000.0000	24960000.0000	10920000.0000	6240000.0000	10920000.0000	0.0000
21060000.0000	46540000.0000	29120000.0000	24960000.0000	10920000.0000	6240000.0000	10920000.0000	0.0000
21060000.0000	46540000.0000	29120000.0000	24960000.0000	10920000.0000	6240000.0000	10920000.0000	0.0000
21060000.0000	46540000.0000	29120000.0000	24960000.0000	10920000.0000	6240000.0000	10920000.0000	0.0000
21060000.0000	23270000.0000	29120000.0000	24960000.0000	10920000.0000	3120000.0000	10920000.0000	0.0000
21060000.0000	23270000.0000	29120000.0000	24960000.0000	10920000.0000	0.0000	10920000.0000	0.0000
21060000.0000	0.0000	29120000.0000	24960000.0000	10920000.0000	0.0000	10920000.0000	0.0000
21060000.0000	0.0000	29120000.0000	24960000.0000	10920000.0000	0.0000	10920000.0000	0.0000
21060000.0000	46540000.0000	29120000.0000	24960000.0000	10920000.0000	6240000.0000	10920000.0000	0.0000
21060000.0000	46540000.0000	29120000.0000	24960000.0000	10920000.0000	6240000.0000	10920000.0000	0.0000
21060000.0000	46540000.0000	29120000.0000	24960000.0000	10920000.0000	6240000.0000	10920000.0000	0.0000
21060000.0000	46540000.0000	29120000.0000	24960000.0000	10920000.0000	6240000.0000	10920000.0000	0.0000
21060000.0000	46540000.0000	29120000.0000	24960000.0000	10920000.0000	6240000.0000	10920000.0000	0.0000
21060000.0000	46540000.0000	29120000.0000	24960000.0000	10920000.0000	6240000.0000	10920000.0000	0.0000
21060000.0000	46540000.0000	14560000.0000	24960000.0000	10920000.0000	6240000.0000	5460000.0000	0.0000
21060000.0000	46540000.0000	14560000.0000	24960000.0000	10920000.0000	6240000.0000	5460000.0000	0.0000
21060000.0000	46540000.0000	0.0000	24960000.0000	10920000.0000	6240000.0000	0.0000	0.0000
21060000.0000	46540000.0000	0.0000	24960000.0000	10920000.0000	6240000.0000	0.0000	0.0000
21060000.0000	46540000.0000	29120000.0000	24960000.0000	10920000.0000	6240000.0000	10920000.0000	0.0000
21060000.0000	46540000.0000	29120000.0000	24960000.0000	10920000.0000	6240000.0000	10920000.0000	0.0000
21060000.0000	46540000.0000	29120000.0000	24960000.0000	10920000.0000	6240000.0000	10920000.0000	0.0000
21060000.0000	46540000.0000	29120000.0000	24960000.0000	10920000.0000	6240000.0000	10920000.0000	0.0000
21060000.0000	46540000.0000	29120000.0000	24960000.0000	10920000.0000	6240000.0000	10920000.0000	0.0000
21060000.0000	46540000.0000	29120000.0000	24960000.0000	10920000.0000	6240000.0000	10920000.0000	0.0000
21060000.0000	46540000.0000	29120000.0000	24960000.0000	10920000.0000	6240000.0000	10920000.0000	0.0000
21060000.0000	46540000.0000	29120000.0000	24960000.0000	10920000.0000	6240000.0000	10920000.0000	0.0000
21060000.0000	46540000.0000	29120000.0000	24960000.0000	10920000.0000	6240000.0000	10920000.0000	0.0000
21060000.0000	46540000.0000	29120000.0000	24960000.0000	10920000.0000	6240000.0000	10920000.0000	0.0000
21060000.0000	46540000.0000	29120000.0000	24960000.0000	10920000.0000	6240000.0000	10920000.0000	0.0000
21060000.0000	46540000.0000	29120000.0000	24960000.0000	10920000.0000	6240000.0000	10920000.0000	0.0000
21060000.0000	46540000.0000	29120000.0000	12480000.0000	10920000.0000	6240000.0000	10920000.0000	0.0000
21060000.0000	46540000.0000	29120000.0000	12480000.0000	10920000.0000	6240000.0000	10920000.0000	0.0000
21060000.0000	46540000.0000	29120000.0000	0.0000	10920000.0000	6240000.0000	10920000.0000	0.0000
21060000.0000	46540000.0000	29120000.0000	0.0000	10920000.0000	6240000.0000	10920000.0000	0.0000
21060000.0000	46540000.0000	29120000.0000	24960000.0000	10920000.0000	6240000.0000	10920000.0000	0.0000
21060000.0000	46540000.0000	29120000.0000	24960000.0000	10920000.0000	6240000.0000	10920000.0000	0.0000
21060000.0000	46540000.0000	29120000.0000	24960000.0000	10920000.0000	6240000.0000	10920000.0000	0.0000
21060000.0000	46540000.0000	29120000.0000	24960000.0000	10920000.0000	6240000.0000	10920000.0000	0.0000
21060000.0000	46540000.0000	29120000.0000	24960000.0000	10920000.0000	6240000.0000	10920000.0000	0.0000
21060000.0000	46540000.0000	29120000.0000	24960000.0000	10920000.0000	6240000.0000	10920000.0000	0.0000
21060000.0000	46540000.0000	29120000.0000	24960000.0000	5460000.0000	6240000.0000	10920000.0000	0.0000
10530000.0000	46540000.0000	29120000.0000	24960000.0000	5460000.0000	6240000.0000	10920000.0000	0.0000
10530000.0000	46540000.0000	29120000.0000	24960000.0000	5460000.0000	6240000.0000	10920000.0000	0.0000
0	46540000.0000	29120000.0000	24960000.0000	0	6240000.0000	10920000.0000	0.0000
21060000.0000	46540000.0000	29120000.0000	24960000.0000	10920000.0000	6240000.0000	10920000.0000	0.0000
21060000.0000	46540000.0000	29120000.0000	24960000.0000	10920000.0000	6240000.0000	10920000.0000	0.0000
21060000.0000	46540000.0000	29120000.0000	24960000.0000	10920000.0000	6240000.0000	10920000.0000	0.0000
21060000.0000	46540000.0000	29120000.0000	24960000.0000	10920000.0000	6240000.0000	10920000.0000	0.0000
21060000.0000	46540000.0000	29120000.0000	24960000.0000	10920000.0000	6240000.0000	10920000.0000	0.0000
21060000.0000	23270000.0000	29120000.0000	24960000.0000	10920000.0000	3120000.0000	10920000.0000	0.0000
21060000.0000	0.0000	29120000.0000	24960000.0000	10920000.0000	0.0000	10920000.0000	0.0000
21060000.0000	46540000.0000	29120000.0000	24960000.0000	10920000.0000	6240000.0000	10920000.0000	0.0000
21060000.0000	46540000.0000	29120000.0000	24960000.0000	10920000.0000	6240000.0000	10920000.0000	0.0000
21060000.0000	46540000.0000	29120000.0000	24960000.0000	10920000.0000	6240000.0000	10920000.0000	0.0000
21060000.0000	46540000.0000	14560000.0000	24960000.0000	10920000.0000	6240000.0000	5460000.0000	0.0000
21060000.0000	46540000.0000	0.0000	24960000.0000	10920000.0000	6240000.0000	0.0000	0.0000
21060000.0000	46540000.0000	29120000.0000	24960000.0000	10920000.0000	6240000.0000	10920000.0000	0.0000
21060000.0000	46540000.0000	29120000.0000	24960000.0000	10920000.0000	6240000.0000	10920000.0000	0.0000
21060000.0000	46540000.0000	29120000.0000	24960000.0000	10920000.0000	6240000.0000	10920000.0000	0.0000
21060000.0000	46540000.0000	29120000.0000	24960000.0000	10920000.0000	6240000.0000	10920000.0000	0.0000
21060000.0000	46540000.0000	29120000.0000	24960000.0000	10920000.0000	6240000.0000	10920000.0000	0.0000
21060000.0000	46540000.0000	29120000.0000	24960000.0000	10920000.0000	6240000.0000	10920000.0000	0.0000
21060000.0000	46540000.0000	29120000.0000	12480000.0000	10920000.0000	6240000.0000	10920000.0000	0.0000
21060000.0000	46540000.0000	29120000.0000	12480000.0000	10920000.0000	6240000.0000	10920000.0000	0.0000
21060000.0000	46540000.0000	29120000.0000	0	10920000.0000	6240000.0000	10920000.0000	0.0000
21060000.0000	46540000.0000	29120000.0000	24960000.0000	10920000.0000	6240000.0000	10920000.0000	0.0000
21060000.0000	46540000.0000	29120000.0000	24960000.0000	10920000.0000	6240000.0000	10920000.0000	0.0000
21060000.0000	46540000.0000	29120000.0000	24960000.0000	10920000.0000	6240000.0000	10920000.0000	0.0000
10530000.0000	46540000.0000	29120000.0000	24960000.0000	5460000.0000	6240000.0000	10920000.0000	0.0000
0	46540000.0000	29120000.0000	24960000.0000	0	6240000.0000	10920000.0000	0.0000
21060000.0000	46540000.0000	29120000.0000	24960000.0000	10920000.0000	6240000.0000	10920000.0000	0.0000
21060000.0000	46540000.0000	29120000.0000	24960000.0000	10920000.0000	6240000.0000	10920000.0000	0.0000
21060000.0000	46540000.0000	29120000.0000	24960000.0000	10920000.0000	6240000.0000	10920000.0000	0.0000
21060000.0000	46540000.0000	29120000.0000	24960000.0000	10920000.0000	6240000.0000	10920000.0000	0.0000
21060000.0000	46540000.0000	29120000.0000	24960000.0000	10920000.0000	6240000.0000	10920000.0000	0.0000
21060000.0000	23270000.0000	29120000.0000	24960000.0000	10920000.0000	3120000.0000	10920000.0000	0.0000
21060000.0000	0.0000	29120000.0000	24960000.0000	10920000.0000	0.0000	10920000.0000	0.0000
21060000.0000	46540000.0000	29120000.0000	24960000.0000	10920000.0000	6240000.0000	10920000.0000	0.0000
21060000.0000	46540000.0000	29120000.0000	24960000.0000	10920000.0000	6240000.0000	10920000.0000	0.0000
21060000.0000	46540000.0000	29120000.0000	24960000.0000	10920000.0000	6240000.0000	10920000.0000	0.0000
21060000.0000	46540000.0000	14560000.0000	24960000.0000	10920000.0000	6240000.0000	5460000.0000	0.0000
];
appendtofile(filename,'MTB_FACILITY',MTB_fac);


%MTB region
%fprintf(fid, strcat('MTB_reg: \t[',num2str(32760),'\t',num2str(7800),']\n'));

