%[x y]=tabellStopDate(100,temps,'9-Feb-2012','31-May-2012')
t=cputime;
model=0;%type of smolt
startdate='16-May-2011';
stopdate='28-Nov-2011';
startdate=datenum(startdate);
stopdate=datenum(stopdate);

load('scenariotemps');%The temperature scenarios are stored in a separate file called scenariotemps.mat. The variable name is scenariotemps.
load('weightclass');
numberofweightclasses=length(weightclass);
[xx yy]=size(scenariotemps);

numberofscenarios=xx;
numberofperiods=floor(stopdate-startdate)/14 +1;
%Trenger en regel for hvilke fisk som det skal brukes henholdsvis S1og S2
%modell for!
filename='SALMONS0_FIRSTSTAGE.dat';
fid=fopen(filename,'w');
fclose(fid);
B=[];
COEFFAll=[];
AAll=[];
CAll=[];

HARVESTweights=[4000 6000];
numberofHARVESTweights=length(HARVESTweights);
tablename='SALMONS0_FIRSTSTAGE';
for k=1:numberofHARVESTweights
    HARVESTweight=HARVESTweights(k);
for j=1:numberofscenarios
    %tablename=strcat('salmonS0_FirstStage_Scenario',num2str(j));
    fprintf(strcat(tablename,'\n'));
    outtable=zeros(numberofperiods, numberofweightclasses);
    coefficients=zeros(numberofweightclasses,1);
    A=zeros(numberofperiods,numberofweightclasses);
    C=zeros(numberofperiods,numberofweightclasses);
    for i=1:numberofweightclasses
        
        [x y]=tabellStopDate(weightclass(i),scenariotemps(j,:),startdate,stopdate,model,HARVESTweight);
        outtable(:,i)=y;
        coefficients(:,i)=findweightclasscoefficients(outtable(numberofperiods,i),weightclass);
        for l=1:numberofperiods
            if outtable(l,i)>=HARVESTweight
                A(l,i)=1;
            end
        end
    end
    B=[B;outtable];
    C=A.*outtable/1000;
    AAll=[AAll;A];
    CAll=[CAll;C];
    COEFFAll=[COEFFAll;coefficients];
%     appendtofile(filename,tablename,outtable);
%     fprintf(fid2,strcat(tablename,'\n'));
%     appendtofile(filename,strcat(tablename,'COEFF'),coefficients);
%     fprintf(fid2,strcat(tablename,'COEFF\n'));
%     appendtofile(filename,strcat(tablename,'HARVEST'),A);
%     fprintf(fid2,strcat(tablename,'HARVEST\n'));
%     appendtofile(filename,strcat(tablename,'PROFIT'),C);
%     fprintf(fid2,strcat(tablename,'PROFIT\n'));
end

end


     appendtofile(filename,tablename,B);
     appendtofile(filename,strcat(tablename,'COEFF'),COEFFAll);
     appendintegermatrixtofile(filename,strcat(tablename,'HARVEST'),AAll);
     appendtofile(filename,strcat(tablename,'PROFIT'),CAll);


    

t2=cputime;
t2-t;