%[x y]=tabellStopDate(100,temps,'9-Feb-2012','31-May-2012')
t=cputime;
model=1;%type of smolt
startdate='16-May-2011';
stopdate='28-Nov-2011';
startdate=datenum(startdate);
stopdate=datenum(stopdate);

load('scenariotemps');%The temperature scenarios are stored in a separate file called scenariotemps.mat. The variable name is scenariotemps.
load('weightclass');
load('averagetemps')
numberofweightclasses=length(weightclass);
[xx yy]=size(scenariotemps);

numberofscenarios=xx;
numberofperiods=floor(stopdate-startdate)/14 +1;
%Trenger en regel for hvilke fisk som det skal brukes henholdsvis S1og S2
%modell for!
filename='SALMONS1_FIRSTSTAGE.dat';
fid=fopen(filename,'w');
fclose(fid);
B=[];
CoeffAll=[];
AAll=[];
CAll=[];
tablename='SALMONS1_FIRSTSTAGE';
harvestweights=[4000 6000];
numberofharvestweights=length(harvestweights);

for k=1:numberofharvestweights
    harvestweight=harvestweights(k);
for j=1:numberofscenarios
    %tablename=strcat('salmonS0_FirstStage_Scenario',num2str(j));
    fprintf(strcat(tablename,'\n'));
    outtable=zeros(numberofperiods, numberofweightclasses);
    coefficients=zeros(numberofweightclasses,1);
    A=zeros(numberofperiods,numberofweightclasses);
    C=zeros(numberofperiods,numberofweightclasses);
    for i=1:numberofweightclasses
        
        [x y]=tabellStopDate(weightclass(i),scenariotemps(j,:),startdate,stopdate,model, harvestweight);
        outtable(:,i)=y;
        coefficients(:,i)=findweightclasscoefficients(outtable(numberofperiods,i),weightclass);
        [p q]=tabellStopDate(weightclass(i),averagetemps,startdate,stopdate,model, harvestweight);
        outtableavg(:,i)=q;
        for l=1:numberofperiods
            if outtable(l,i)>=harvestweight
                A(l,i)=1;
            end
        end
    end
    B=[B;outtable];
    C=A.*outtable/1000;
    AAll=[AAll;A];
    CAll=[CAll;C];
    CoeffAll=[CoeffAll;coefficients];
%     appendtofile(filename,tablename,outtable);
%     fprintf(fid2,strcat(tablename,'\n'));
%     appendtofile(filename,strcat(tablename,'Coeff'),coefficients);
%     fprintf(fid2,strcat(tablename,'Coeff\n'));
%     appendtofile(filename,strcat(tablename,'Harvest'),A);
%     fprintf(fid2,strcat(tablename,'Harvest\n'));
%     appendtofile(filename,strcat(tablename,'Profit'),C);
%     fprintf(fid2,strcat(tablename,'Profit\n'));
end
end

     appendtofile(filename,tablename,outtableavg);
     appendtofile(filename,strcat(tablename,'COEFF'),CoeffAll);
     %appendintegermatrixtofile(filename,strcat(tablename,'HARVEST'),AAll);
     %appendtofile(filename,strcat(tablename,'PROFIT'),CAll);


    

t2=cputime;
t2-t;