%[x y]=tabellStopDate(100,temps,'9-Feb-2012','31-May-2012')
t=cputime;
model=1;
startdate='28-nov-2011';
stopdate='10-June-2013';
stoptwoweeksdate='10-june-2013';
startdate=datenum(startdate);
stopdate=datenum(stopdate);
stoptwoweeksdate=datenum(stoptwoweeksdate);
load('averagetemps');%The temperature scenarios are stored in a separate file called scenariotemps.mat. The variable name is scenariotemps.
load('weightclass');
numberofweightclasses=length(weightclass);


numberofperiods=floor(stopdate-startdate)/14 +1;
numberoftwoweeksperiods=floor(stoptwoweeksdate-startdate)/14 +1;
filename='SALMONS1_SECONDSTAGE.dat';
fid=fopen(filename,'w');
fclose(fid);


tablename='SALMONS1_SECONDSTAGE';
fprintf(strcat(tablename,'\n'));
outtable=zeros(numberofperiods, numberofweightclasses);

HARVESTweights=[4000 6000];
numberofHARVESTweights=length(HARVESTweights);

  Weight=[]; 
for k=1:numberofHARVESTweights
    HARVESTweight=HARVESTweights(k);
    for i=1:numberofweightclasses
        
        [x y]=tabellStopDate(weightclass(i),averagetemps,startdate,stopdate,model,HARVESTweight);
        outtable(:,i)=y;
       
    end
    
    
    Weight=[Weight;outtable(1:numberoftwoweeksperiods,:);outtable(numberoftwoweeksperiods+1:2:numberofperiods,:)];
    
end
    [x y]=size(Weight);
    A=zeros(x,y);
    C=zeros(x,y);
    l=x;
    l2=l;
    m=x/2;
    m2=m;

 for k=1:numberofweightclasses
    while Weight(l,k)==0
           l=l-1;  
    end

     if l~=l2
           A(l,k)=1;
      elseif Weight(l,k)>=5600
           A(l,k)=1;
     end
       l=x;
     while Weight(m,k)==0
         m=m-1;
     end
     if m~=m2
         A(m,k)=1;
     elseif Weight(m,k)>=3800
         A(m,k)=1;
     end
 end
    C=A.*Weight/1000;
    appendtofile(filename,tablename,Weight);
    
    appendintegermatrixtofile(filename,strcat(tablename,'HARVEST'),A);

    appendtofile(filename,strcat(tablename,'PROFIT'),C);

 

t2=cputime;
t2-t;